package parsekit

import (
	"testing"

	"git.makaay.nl/mauricem/go-parsekit/assert"
)

func TestSetResult_AcceptsVariousTypesAsInput(t *testing.T) {
	i := mkInput()
	i.Result().SetRunes("string")
	assert.Equal(t, "string", string(i.Result().String()), "i.Result() with string input")
	i.Result().SetRunes([]rune("rune slice"))
	assert.Equal(t, "rune slice", string(i.Result().String()), "i.Result() with rune slice input")
	i.Result().SetRunes('X')
	assert.Equal(t, "X", string(i.Result().String()), "i.Result() with rune input")
}

func TestSetResult_PanicsOnUnhandledInput(t *testing.T) {
	assert.Panic(t, assert.PanicT{
		Function: func() {
			i := mkInput()
			i.Result().SetRunes(1234567)
		},
		Expect: "parsekit.Result.SetRunes(): unsupported type 'int' used",
	})
}
